#include <iostream>
#include <limits>

using namespace std;

int main()
{
    int N;
    cin>>N;
    int A[N];
    for(int i = 0; i < N; i++)
    {
        cin>>A[i];
    }
    int Q;
    cin>>Q;
    int l[Q];
    int r[Q];
    bool Resenja[Q];
    for(int i = 0; i < Q; i++)
    {
        cin>>l[i]>>r[i];
        int X=0;
        int Prosli = INT_MAX;
        for(int j = l[i]; j<r[i]; j++)
        {
            if(A[j]<A[j-1])
            {
                X++;
                if(A[j-1]-A[j]>Prosli && j!=r[i]-1)
                {
                    X++;
                }
            }
            Prosli = A[j]-A[j-1];
            if(X>=2)
            {
                j=r[i];
            }
        }
        Resenja[i]=X<2;
    }
    for(int i = 0; i < Q; i++)
    {
        if(Resenja[i])
        {
            cout<<"DA"<<endl;
        }
        else
        {
            cout<<"NE"<<endl;
        }
    }
    return 0;
}